import { CodexMetaTypeEnum, CountryCode, LanguageCode } from "@cryptexlabs/codex-data-model";
import { HostConfigInterface } from "./host-config.interface";
import { SwitchConfigInterface } from "./switch-config.interface";
import { KafkaConfigInterface } from "./kafka-config.interface";
import { JwtConfigInterface } from "./jwt-config.interface";
import { UrlInterface } from "./url.interface";
import { PingConfigInterface } from "./ping-config.interface";
import { ConsumerTypeEnum } from "./consumer-type.enum";
import { JsonSerializableInterface } from "../message";
import { TelemetryConfigInterface } from "./telemetry-config.interface";
import { LOG_LEVEL } from "./logging-config.interface";
import { RedisConfigInterface } from "./redis-config.interface";
import { SqlConfigInterface } from "./sql-config.interface";
import { PaginationConfigInterface } from "./pagination-config.interface";
export declare class DefaultConfig implements JsonSerializableInterface<any> {
    private readonly _clientId;
    private _appName;
    private _serverConfig;
    private _configUpdateQueue;
    private _monitors;
    private _pathsWatching;
    private readonly _basePath;
    private readonly _envName;
    private _packageVersion;
    private readonly _appPath;
    private _configChangeLoaderEventHandler;
    private _logger;
    constructor(basePath: string, appPath: string, _clientId: string, fallbackEnvironment?: string);
    setConfigChangeLoaderEventHandler(eventHandler: () => Promise<void>): void;
    private _onConfigUpdateQueueMessage;
    getServerConfig<C = any>(): C;
    private _loadServerConfig;
    private _startConfigPatchWatch;
    private _loadConfigPath;
    private _loadConfigPatterns;
    private get _hotReload();
    toJSON(): {
        fallbackLanguage: LanguageCode;
        fallbackCountry: CountryCode;
        appVersion: string;
        appName: string;
        clientId: string;
        apiVersion: string;
        appPrefix: string;
        docsPrefix: string;
        docsEnabled: boolean;
        docsPath: string;
        kafka: KafkaConfigInterface;
        environmentName: string;
        logLevels: string[];
        httpPort: number;
        metrics: SwitchConfigInterface & HostConfigInterface;
        jwt: JwtConfigInterface;
        healthzFilePath: string;
        elasticsearch: UrlInterface & PingConfigInterface;
        consumerType: ConsumerTypeEnum;
        gpuEnabled: boolean;
        dataDirectory: string;
        serviceName: string;
        logLevel: LOG_LEVEL;
        loggerType: string;
        telemetry: TelemetryConfigInterface;
    };
    protected setup(basePath: string, appPath: string, environment: string): void;
    addEnvFile(fileName: string): this;
    get fallbackLanguage(): LanguageCode;
    get fallbackCountry(): CountryCode;
    get appVersion(): string;
    get appName(): string;
    get clientId(): string;
    get apiVersion(): string;
    get appPrefix(): string;
    get docsPrefix(): string;
    get docsEnabled(): boolean;
    get docsPath(): string;
    get kafka(): KafkaConfigInterface;
    get serviceName(): string;
    get environmentName(): string;
    get logLevels(): string[];
    get loggerType(): string;
    get logLevel(): LOG_LEVEL;
    get httpPort(): number;
    get externalHttpPort(): number;
    get metrics(): SwitchConfigInterface & HostConfigInterface;
    get telemetry(): TelemetryConfigInterface;
    get jwt(): JwtConfigInterface;
    get healthzFilePath(): string;
    get elasticsearch(): UrlInterface & PingConfigInterface;
    get consumerType(): ConsumerTypeEnum;
    get gpuEnabled(): boolean;
    get dataDirectory(): string;
    get overrideOrganization(): string;
    getMetaType(type: CodexMetaTypeEnum): CodexMetaTypeEnum;
    get apiPrefixes(): string[];
    get prettyPrintLogs(): boolean;
    get redis(): RedisConfigInterface;
    get pagination(): PaginationConfigInterface;
    get sql(): SqlConfigInterface;
    get authfUrl(): string;
    get authEnabled(): boolean;
    get blacklistRefreshIntervalInSeconds(): number;
}
